(*
   Copyright 2012 by Mark Weyer
*)

type polynomial = bool array
  (* We identify bool with F_2.
     Entry i of the array is the coefficient for x^i. *)

val crc32 : polynomial

class type crc_run = object
  method read_bit : bool -> unit
  method read_byte_little_endian : int -> unit
  method remainder : polynomial
end

class type crc = object
  method start_run : crc_run
end

type spec = {
  polynomial : polynomial;
  initial_remainder : polynomial;
  }

val crc : spec -> crc

